# -*- coding:Utf-8 -*-
import es, re, psyco, random, langlib, popuplib, playerlib, gamethread
psyco.full()

gamename = es.getGameName()
def importSimpleMenuLib():
    try:
        global simplemenulib
        import simplemenulib
        return True
    except ImportError: return False

def downloadFromESAM(install = False):
    if gamename <> "hl2mp":
        if not importSimpleMenuLib():
            if not install:
                import installlib
                simplemenu = installlib.getInstaller('simplemenu')
                simplemenu.update(True)
                gamethread.delayed(2, downloadFromESAM, True)
            else: raise ImportError, "say_sound: module simplemenulib is required (http://addons.eventscripts.com/addons/view/simplemenu)"
downloadFromESAM()


esInfo = es.AddonInfo()
esInfo.author = "DoCky"
esInfo.version = "2.008p"
esInfo.date = "2010/09/11"
esInfo.basename = "say_sound"
esInfo.name = "Say Sound"
esInfo.url = "http://addons.eventscripts.com/addons/user/11751"

cvMenu = es.ServerVar("ss_menu", "", "[Say Sound] command of player's configuration panel")
cvVolume = es.ServerVar("ss_volume", "", "[Say Sound] volume (0 ~ 1)")
cvCreditMode = es.ServerVar("ss_creditmode", "", "[Say Sound] credit restored mode (round or time)")
cvPlaymax = es.ServerVar("ss_playmax", "", "[Say Sound] max sound played by round (0 for no limit)")
cvPlaymode = es.ServerVar("ss_playmode", "", "[Say Sound] mode to play the sound (0 or 1)")
cvUseronly = es.ServerVar("ss_useronly", "", "[Say Sound] play sound to all players or activator only\n - 0 or 1 (work only if ss_playmode is set to 0)")
cvAttenuation = es.ServerVar("ss_attenuation", "", "[Say Sound] attenuation of emited sound\n - 0 ~ 1 (work only if ss_playmode is set to 1)")


version = es.ServerVar("say_sound", "", " Created by DoCky -")
version.set(esInfo.version)
version.makepublic()

words = {}
players = {}
popupmenus = set()
regex = re.compile('//.*|(\r|\n|")+')
gamedir = es.getString("eventscripts_gamedir")


############################
# ESCMENU
def esclist(userid):
    wordlist = words.keys()
    wordlist.sort()
    name = "_say_sound_list_"  + str(userid)
    popupmenus.add(name)

    menu = popuplib.easymenu("_say_sound_list_"  + str(userid), None, escSelectSound)
    menu.editlang = "en"
    menu.settitle(message(userid, "word list")) 
    for word in wordlist: menu.addoption(word, message(userid, "list sound name", {"name" : word}))
    menu.send(userid)

def escSelectSound(userid, choice, popup):
    es.sexec(userid, "say " + choice)
    gamethread.queue(popuplib.send, (popup, userid))


############################
# SIMPLEMENU
def simplelist():
    wordlist = words.keys()
    wordlist.sort()
    menu = simplemenulib.menu("_say_sound_list")
    menu.loadlang("cfg/say_sound/language.ini")
    menu.title("word list", showpage = len(words) > 8)
    for word in wordlist: menu.addchoice("list sound name", word, {"$name" : word})
    menu.popupreturn("_say_sound_panel")
    menu.blockselect = menuSelectSound
    menu.addlist("_say_sound_menus")

def menuSelectSound(userid, index, choice, value, name, page):
    es.sexec(userid, "say " + value)
    simplemenulib.send(userid, name, page)


############################
# FUNCTIONS
def init():
    try:
        openfile = open(gamedir + "/cfg/say_sound/wordlist.txt", "r")
        for line in map(lambda line: regex.sub("", line).strip(), openfile.readlines()):
            if line:
                try:
                    word, path = map(lambda elem: elem.strip().strip('"'), line.split("="))
                    if not words.has_key(word): words[word] = []
                    words[word].append(path)
                except ValueError: es.dbgmsg(0, 'say_sound: invalid syntax in wordlist.txt for line:\n - "%s"' % line)
        openfile.close()
    except IOError: es.dbgmsg(0, "say_sound: cannot read file wordlist.txt")

    global language
    es.mexec("say_sound/config.cfg")
    language = langlib.Strings(gamedir + "/cfg/say_sound/language.ini")
    for userid in es.getUseridList(): addplayer(userid)
    if str(cvCreditMode) <> "round": restoreCredit(True)
    if gamename <> "hl2mp": simplelist()

def restoreCredit(next = False):
    for uniqueid in players: players[uniqueid][0] = int(cvPlaymax)
    if next: gamethread.delayedname(float(cvCreditMode) * 60, "_say_sound_restore_delay", restoreCredit, True)

def addplayer(userid):
    userid = int(userid)
    uniqueid = playerlib.uniqueid(userid)
    if not players.has_key(uniqueid): players[uniqueid] = [int(cvPlaymax), True, "en"]
    else: players[uniqueid][0] = int(cvPlaymax)
    lang = es.getclientvar(userid, "cl_language")
    if lang: players[uniqueid][2] = langlib.getLangAbbreviation(lang)

def playsound(userid, word):
    playmax, letplay = int(cvPlaymax), False
    uniqueid = playerlib.uniqueid(userid)
    if not players.has_key(uniqueid): addplayer(userid)
    player = players[uniqueid]

    if not playmax: letplay = True
    elif player[0] > 0:
        letplay = True
        player[0] -= 1
        soundleft = player[0]
        if soundleft: es.tell(userid, "#multi", message(userid, "sound left", {"credit" : soundleft, "total" : int(cvPlaymax)}))
        else: es.tell(userid, "#multi", message(userid, "cannot play"))

    if letplay:
        sound = random.choice(words[word])
        if bool(cvPlaymode): es.emitsound("player", userid, sound, float(cvVolume), float(cvAttenuation))
        else:
            if bool(cvUseronly):
                if players[uniqueid][1]: es.playsound(userid, sound, float(cvVolume))
            else:
                for player in playerlib.getPlayerList("#all"):
                    try:
                        if players[str(player.uniqueid)][1]: es.playsound(player.userid, sound, float(cvVolume))
                    except KeyError: pass
    else: es.tell(userid, "#multi", message(userid, "cannot play"))

def message(userid, section, tokens = {}):
    lang = players[playerlib.uniqueid(userid)][2]
    return language(section, tokens, lang if language[section].has_key(lang) else "en")

def sendpanel():
    userid = es.getcmduserid()
    uniqueid = playerlib.uniqueid(userid)
    if not players.has_key(uniqueid): addplayer(userid)
    status = players[uniqueid][1]

    menu = popuplib.create("_say_sound_panel")
    menu.addline("->1. " + message(userid, "option sound " + "on" if status else "off"))
    menu.addline("->2. " + message(userid, "option sound list"))
    if gamename == "hl2mp": menu.vguititle = message(userid, "user option")
    else:
        menu.insline(1, message(userid, "user option"))
        menu.addline("0. " + message(userid, "_smlib_exit"))
    popupmenus.add("_say_sound_panel")
    menu.menuselect = panelSelect

    if popuplib.isqueued("_say_sound_panel", userid): menu.update(userid)
    else:
        menutosend = True
        if gamename == "hl2mp":
            active = popuplib.active(userid)["name"]
            # remove escmenu from player's queue
            if active  == "_say_sound_list_"  + str(userid): popuplib.close(active, userid)
        elif simplemenulib.active(userid)["name"] == "_say_sound_list": menutosend = False
        if menutosend: menu.send(userid)

def panelSelect(userid, choice, popup):
    if choice == 1:
        uniqueid = playerlib.uniqueid(userid)
        if players[uniqueid][1]:
            players[uniqueid][1] = False
            popuplib.find(popup).modline(1 if gamename == "hl2mp" else 2, "->1. " + message(userid, "option sound off"))
        else:
            players[uniqueid][1] = True
            popuplib.find(popup).modline(1 if gamename == "hl2mp" else 2, "->1. " + message(userid, "option sound on"))
        gamethread.queue(popuplib.send, (popup, userid))
    elif choice == 2:
        if gamename == "hl2mp": esclist(userid)
        else: simplemenulib.send(userid, "_say_sound_list")


############################
# EVENTS
def unload():
    gamethread.cancelDelayed("_say_sound_restore_delay")
    command = str(cvMenu)
    if command:
        es.unregsaycmd(command)
        es.unregclientcmd(command)
    if gamename <> "hl2mp": simplemenulib.dellist("_say_sound_menus")
    else:
        for menu in popupmenus: popuplib.delete(menu)
        popupmenus.clear()

def load():
    init()
    command = str(cvMenu)
    if command:
        es.regsaycmd(command, "say_sound/sendpanel", "[Say Sound] command of player's configuration panel")
        es.regclientcmd(command, "say_sound/sendpanel", "[Say Sound] command of player's configuration panel")

def es_map_start(event):
    gamethread.cancelDelayed("_say_sound_restore_delay")
    if gamename <> "hl2mp": simplemenulib.dellist("_say_sound_menus")
    else:
        for menu in popupmenus: popuplib.delete(menu)
        popupmenus.clear()
    init()

def round_start(event):
    if str(cvCreditMode) == "round": restoreCredit()

def player_say(event):
    word = event["text"]
    if words.has_key(word): playsound(event["userid"], word)
